
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java RESTful Web Service实战（第2版） 2.3　传输格式 / iVAN</title>

    <meta name="description" content="Java RESTful Web Service实战（第2版） 2.3　传输格式 2.3 传输格式 本节要考虑的就是如何设计表述,即传输过程中数据采用什么样的数据格式.通常,REST接口会以XML和JSON作为主要的传输格式,这两种格式数据的处理是本节的重点.那么Jersey是否还支持其他的数据格式呢?答案是肯定的,让我们逐一掌握各种类型的实现. 2.3.1 基本类型 Java的基本类型又叫原生类型,包括4种整型(byte.short.int.long).2种浮点类型(float.double).Unicode编码的字符(char)和布尔类型(boolean). 阅读指南 本">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Java RESTful Web Service实战（第2版） 2.3　传输格式</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><b>2.3　传输格式</b></p>
<p>本节要考虑的就是如何设计表述，即传输过程中数据采用什么样的数据格式。通常，REST接口会以XML和JSON作为主要的传输格式，这两种格式数据的处理是本节的重点。那么Jersey是否还支持其他的数据格式呢？答案是肯定的，让我们逐一掌握各种类型的实现。</p>
<p><b>2.3.1　基本类型</b></p>
<p>Java的基本类型又叫原生类型，包括4种整型（byte、short、int、long）、2种浮点类型（float、double）、Unicode编码的字符（char）和布尔类型（boolean）。</p>
<p>阅读指南</p>
<p>本节的前4小节示例源代码地址：https://github.com/feuyeux/jax-rs2-guide-II/tree/master/2.simple-service-3。</p>
<p>相关包：com.example.response。</p>
<p>Jersey支持全部的基本类型，还支持与之相关的引用类型。前述示例已经呈现了整型（int）等Java的基本类型的参数，本例展示字节数组类型作为请求实体类型、字符串作为响应实体类型的示例，示例代码如下。</p>
<p>@POST</p>
<p>@Path("b")</p>
<p>public String postBytes(final byte[] bs)<br />
{//关注点1：测试方法入参</p>
<p>   <br />
for (final byte b : bs) {</p>
<p>   <br />
LOGGER.debug(b);</p>
<p>    }</p>
<p>   <br />
return "byte[]:" + new String(bs);</p>
<p>}</p>
<p>@Test</p>
<p>public void testBytes() {</p>
<p>   <br />
final String message = "TEST STRING";</p>
<p>   <br />
final Builder request = target(path).path("b").request();</p>
<p>   <br />
final Response response = request.post(</p>
<p>Entity.entity(message,<br />
MediaType.TEXT_PLAIN_TYPE), Response.class);</p>
<p>   <br />
result = response.readEntity(String.class);</p>
<p>//关注点2：测试断言</p>
<p>   <br />
Assert.assertEquals("byte[]:" + message, result);</p>
<p>}</p>
<p>在这段代码中，资源方法postBytes()的输入参数是byte[]类型，输出参数是String类型，见关注点1；单元测试方法testBytes()的断言是对字符串"TEST STRING"的验证，见关注点2。</p>
<p>2.3.2　文件类型</p>
<p>Jersey支持传输File类型的数据，以方便客户端直接传递File类实例给服务器端。文件类型的请求，默认使用的媒体类型是Content-Type: text/html，示例代码如下。</p>
<p>@POST</p>
<p>@Path("f")</p>
<p>//关注点1：测试方法入参</p>
<p>public File postFile(final File f) throws<br />
FileNotFoundException, IOException {</p>
<p>//关注点2：try-with-resources</p>
<p>   <br />
try (BufferedReader br = new BufferedReader(new FileReader(f))) {</p>
<p>       <br />
String s;</p>
<p>       <br />
do {</p>
<p>           <br />
s = br.readLine();</p>
<p>           <br />
LOGGER.debug(s);</p>
<p>        } while (s != null);</p>
<p>       <br />
return f;</p>
<p>    }</p>
<p>}</p>
<p>@Test</p>
<p>public void testFile() throws<br />
FileNotFoundException, IOException {</p>
<p>//关注点3：获取文件全路径</p>
<p>   <br />
final URL resource =<br />
getClass().getClassLoader().getResource("gua.txt");</p>
<p>//关注点4：构建File实例</p>
<p>   <br />
final String file = resource.getFile();</p>
<p>   <br />
final File f = new File(file);</p>
<p>   <br />
final Builder request = target(path).path("f").request();</p>
<p>//关注点5：提交POST请求</p>
<p>   <br />
Entity&lt;File&gt; e = Entity.entity(f, MediaType.TEXT_PLAIN_TYPE);</p>
<p>   <br />
final Response response = request.post(e, Response.class);</p>
<p>   <br />
File result = response.readEntity(File.class);</p>
<p>   <br />
try (BufferedReader br = new BufferedReader(new FileReader(result))) {</p>
<p>       <br />
String s;</p>
<p>       <br />
do {</p>
<p>           <br />
s = br.readLine();//关注点6：逐行读取文件</p>
<p>           <br />
LOGGER.debug(s);</p>
<p>       <br />
} while (s != null);</p>
<p>    }</p>
<p>}</p>
<p>在这段代码中，资源方法postFile()的输入参数类型和返回值类型都是File类型，见关注点1；服务器端对File实例进行解析，最后将该资源释放，即try-with-resources，见关注点2；在测试方法testFile()中，构建了File类型的"gua.txt"文件的实例，见关注点3；作为请求实体提交，见关注点4；并对响应实体进行逐行读取的校验，见关注点5；需要注意的是，由于我们使用的是Maven构建的项目，测试文件位于测试目录的resources目录，其相对路径为/simple-service-3/src/test/resources/gua.txt，获取该文件的语句为getClass().getClassLoader().getResource("gua.txt")，见关注点6。</p>
<p>另外，文件的资源释放使用了JDK7的try-with-resources语法，见关注点2。</p>
<p>2.3.3　InputStream类型</p>
<p>Jersey支持Java的两大读写模式，即字节流和字符流。本示例展示字节流作为REST方法参数，示例如下。</p>
<p>@POST</p>
<p>@Path("bio")</p>
<p>//关注点1：资源方法入参</p>
<p>public String postStream(final InputStream<br />
is) throws FileNotFoundException, IOException {</p>
<p>//关注点2：try-with-resources</p>
<p>   <br />
try (BufferedReader br = new BufferedReader(new InputStreamReader(is)))<br />
{</p>
<p>       <br />
StringBuilder result = new StringBuilder();</p>
<p>       <br />
String s = br.readLine();</p>
<p>       <br />
while (s != null) {</p>
<p>           <br />
result.append(s).append("\n");</p>
<p>           <br />
LOGGER.debug(s);</p>
<p>           <br />
s = br.readLine();</p>
<p>       <br />
}</p>
<p>       <br />
return result.toString();//关注点3：资源方法返回值</p>
<p>    }</p>
<p>}</p>
<p>@Test</p>
<p>public void testStream() {</p>
<p>//关注点4：获取文件全路径</p>
<p>   <br />
final InputStream resource =<br />
getClass().getClassLoader().getResourceAsStream("gua.txt");</p>
<p>   <br />
final Builder request = target(path).path("bio").request();</p>
<p>   <br />
Entity&lt;InputStream&gt; e = Entity.entity(resource,<br />
MediaType.TEXT_PLAIN_TYPE);</p>
<p>   <br />
final Response response = request.post(e, Response.class);</p>
<p>   <br />
result = response.readEntity(String.class);</p>
<p>//关注点5：输出返回值内容</p>
<p>   <br />
LOGGER.debug(result);</p>
<p>}</p>
<p>在这段代码中，资源方法postStream()的输入参数类型是InputStream，见关注点1；服务器端从中读取字节流，并最终释放该资源，见关注点2；返回值是String类型，内容是字节流信息，见关注点3；测试方法testStream()构建了"gua.txt"文件内容的字节流，作为请求实体提交，见关注点4；响应实体预期为String类型的"gua.txt"文件内容信息，见关注点5。</p>
<p>2.3.4　Reader类型</p>
<p>本示例展示另一种Java读写模式，以字符流作为REST方法参数，示例如下。</p>
<p>@POST</p>
<p>@Path("cio")</p>
<p>//关注点1：资源方法入参</p>
<p>public String postChars(final Reader r)<br />
throws FileNotFoundException, IOException {</p>
<p>//关注点2：try-with-resources</p>
<p>   <br />
try (BufferedReader br = new BufferedReader(r)) {</p>
<p>       <br />
String s = br.readLine();</p>
<p>       <br />
if (s == null) {</p>
<p>           <br />
throw new Jaxrs2GuideNotFoundException("NOT FOUND FROM<br />
READER");</p>
<p>       <br />
}</p>
<p>       <br />
while (s != null) {</p>
<p>           <br />
LOGGER.debug(s);</p>
<p>           <br />
s = br.readLine();</p>
<p>       <br />
}</p>
<p>       <br />
return "reader";</p>
<p>    }</p>
<p>}</p>
<p>@Test</p>
<p>public void testReader() {</p>
<p>//关注点3：构建并提交Reader实例</p>
<p>   <br />
ClassLoader classLoader = getClass().getClassLoader();</p>
<p>   <br />
final Reader resource =</p>
<p>new<br />
InputStreamReader(classLoader.getResourceAsStream("gua.txt"));</p>
<p>   <br />
final Builder request = target(path).path("cio").request();</p>
<p>   <br />
Entity&lt;Reader&gt; e = Entity.entity(resource,<br />
MediaType.TEXT_PLAIN_TYPE);</p>
<p>   <br />
final Response response = request.post(e, Response.class);</p>
<p>   <br />
result = response.readEntity(String.class);</p>
<p>//关注点4：输出返回值内容</p>
<p>   <br />
LOGGER.debug(result);</p>
<p>}</p>
<p>在这段代码中，资源方法postChars()的输入参数类型是Reader，见关注点1；服务器端从中读取字符流，并最终释放该资源，返回值是String类型，见关注点2；测试方法testReader()构建了"gua.txt"文件内容的Reader实例，将字符流作为请求实体提交，见关注点3；响应实体预期为String类型的"gua.txt"文件内容信息，见关注点4。</p>
<p>2.3.5　XML类型</p>
<p>XML类型是使用最广泛的数据类型。Jersey对XML类型的数据处理，支持Java领域的两大标准，即JAXP（Java API for<br />
XML Processing，JSR-206）和JAXB（Java Architecture for XML Binding，JSR-222）。</p>
<p>阅读指南</p>
<p>本节示例源代码地址：https://github.com/feuyeux/jax-rs2-guide-II/tree/master/2.simple-service-3。</p>
<p>相关包：com.example.media.xml。</p>
<p>1. JAXP标准</p>
<p>JAXP包含了DOM、SAX和StAX 3种解析XML的技术标准。</p>
<p>DOM是面向文档解析的技术，要求将XML数据全部加载到内存，映射为树和结点模型以实现解析。</p>
<p>SAX是事件驱动的流解析技术，通过监听注册事件，触发回调方法以实现解析。</p>
<p>StAX是拉式流解析技术，相对于SAX的事件驱动推送技术，拉式解析使得读取过程可以主动推进当前XML位置的指针而不是被动获得解析中的XML数据。</p>
<p>对应的，JAXP定义了3种标准类型的输入接口Source（DOMSource，SAXSource，StreamSource）和输出接口Result（DOMResult，SAXResult，StreamResult）。Jersey可以使用JAXP的输入类型作为REST方法的参数，示例代码如下。</p>
<p>@POST</p>
<p>@Path("stream")</p>
<p>@Consumes(MediaType.APPLICATION_XML)</p>
<p>@Produces(MediaType.APPLICATION_XML)</p>
<p>public StreamSource getStreamSource(</p>
<p>javax.xml.transform.stream.StreamSource<br />
streamSource) {</p>
<p>//关注点1：资源方法入参</p>
<p>   <br />
return streamSource;</p>
<p>}</p>
<p>@POST</p>
<p>@Path("sax")</p>
<p>@Consumes(MediaType.APPLICATION_XML)</p>
<p>@Produces(MediaType.APPLICATION_XML)</p>
<p>//关注点2：支持SAX技术</p>
<p>public SAXSource<br />
getSAXSource(javax.xml.transform.sax.SAXSource saxSource) {</p>
<p>   <br />
return saxSource;</p>
<p>}</p>
<p>@POST</p>
<p>@Path("dom")</p>
<p>@Consumes(MediaType.APPLICATION_XML)</p>
<p>@Produces(MediaType.APPLICATION_XML)</p>
<p>//关注点3：支持DOM技术</p>
<p>public DOMSource<br />
getDOMSource(javax.xml.transform.dom.DOMSource domSource) {</p>
<p>   <br />
return domSource;</p>
<p>}</p>
<p>@POST</p>
<p>@Path("doc")</p>
<p>@Consumes(MediaType.APPLICATION_XML)</p>
<p>@Produces(MediaType.APPLICATION_XML)</p>
<p>//关注点4：支持DOM技术</p>
<p>public Document<br />
getDocument(org.w3c.dom.Document document) {</p>
<p>   <br />
return document;</p>
<p>}</p>
<p>在这段代码中，资源方法getStreamSource()使用StAX拉式流解析技术支持输入输出类型为StreamSource的请求，见关注点1；getSAXSource()方法使用SAX是事件驱动的流解析技术支持输入输出类型为SAXSource的请求，见关注点2；getDOMSource()方法和getDocument()方法使用DOM面向文档解析的技术，支持输入输出类型分别为DOMSource和Document的请求，见关注点3和关注点4。</p>
<p>2. JAXB标准</p>
<p>JAXP的缺点是需要编码解析XML，这增加了开发成本，但对业务逻辑的实现并没有实质的贡献。JAXB只需要在POJO中定义相关的注解（早期人们使用XML配置文件来做这件事），使其和XML的schema对应，无须对XML进行程序式解析，弥补了JAXP的这一缺点，因此本书推荐使用JAXB作为XML解析的技术。</p>
<p>JAXB通过序列化和反序列化实现了XML数据和POJO对象的自动转换过程。在运行时，JAXB通过编组（marshall）过程将POJO序列化成XML格式的数据，通过解编（unmarshall）过程将XML格式的数据反序列化为Java对象。JAXB的注解位于javax.xml.bind.annotation包中，详情可以访问JAXB的参考实现网址是https://jaxb.java.net/tutorial。</p>
<p>需要指出的是，从理论上讲，JAXB解析XML的性能不如JAXP，但使用JAXB的开发效率很高。笔者所在的开发团队使用JAXB解析XML，从实践体会而言，笔者并不支持JAXB影响系统运行性能这样的观点。因为计算机执行的瓶颈在IO，而无论使用哪种技术解析，XML数据本身是一样的，区别仅在于解析手段。而REST风格以及敏捷思想的宗旨就是简单—开发过程简单化、执行逻辑简单化，因此如果连XML数据都趋于简单，JAXP带来的性能优势就可以忽略不计了。综合考量，实现起来更简单的JAXB更适合做REST开发。</p>
<p>Jersey支持使用JAXBElement作为REST方法参数的形式，也支持直接使用POJO作为REST方法参数的形式，后一种更为常用，示例代码如下。</p>
<p>@POST</p>
<p>@Path("jaxb")</p>
<p>@Consumes(MediaType.APPLICATION_XML)</p>
<p>@Produces(MediaType.APPLICATION_XML)</p>
<p>public Book<br />
getEntity(JAXBElement&lt;Book&gt; bookElement) {</p>
<p>   <br />
Book book = bookElement.getValue();</p>
<p>   <br />
LOGGER.debug(book.getBookName());</p>
<p>   <br />
return book;</p>
<p>}</p>
<p>@POST</p>
<p>@Consumes({ MediaType.APPLICATION_XML,<br />
MediaType.APPLICATION_JSON })</p>
<p>@Produces(MediaType.APPLICATION_XML)</p>
<p>public Book getEntity(Book book) {</p>
<p>   <br />
LOGGER.debug(book.getBookName());</p>
<p>   <br />
return book;</p>
<p>}</p>
<p>以上JAXP和JAXB的测试如下所示，其传输内容是相同的，不同在于服务器端的REST方法定义的解析类型和返回值类型。</p>
<p>1 &gt; Content-Type: application/xml</p>
<p>&lt;?xml version="1.0"<br />
encoding="UTF-8" standalone="yes"?&gt;&lt;book<br />
bookId="100" bookName="TEST BOOK"/&gt;</p>
<p>2 &lt; Content-Length: 79</p>
<p>2 &lt; Content-Type: text/html</p>
<p>&lt;?xml version="1.0"<br />
encoding="UTF-8"?&gt;&lt;book bookId="100"<br />
bookName="TEST BOOK"/&gt;</p>
<p>从测试结果可以看到，POJO类的字段是作为XML的属性组织起来的，详见如下的图书实体类定义。</p>
<p>@XmlRootElement</p>
<p>public class Book implements Serializable {</p>
<p>//关注点1：JAXB属性注解</p>
<p>   <br />
@XmlAttribute(name = "bookId")</p>
<p>   <br />
public Long getBookId() {</p>
<p>       <br />
return bookId;</p>
<p>    }</p>
<p>   <br />
@XmlAttribute(name = "bookName")</p>
<p>   <br />
public String getBookName() {</p>
<p>       <br />
return bookName;</p>
<p>    }</p>
<p>   <br />
@XmlAttribute(name = "publisher")</p>
<p>   <br />
public String getPublisher() {</p>
<p>       <br />
return publisher;</p>
<p>    }</p>
<p>}</p>
<p>（1）property和element</p>
<p>本例的POJO类Book的字段都定义为XML的属性（property）来组织，POJO的字段也可以作为元素（element）组织，见关注点1。如何定义通常取决于对接系统的设计。需要注意的是，如果REST请求的传输数据量很大，并且无须和外系统对接的场景，建议使用属性来组织XML，这样可以极大地减少XML格式的数据包的大小。</p>
<p>（2）XML_SECURITY_DISABLE</p>
<p>Jersey默认设置了XMLConstants.FEATURE_SECURE_PROCESSING（http://javax.xml.XML<br />
Constants/feature/secure-processing）属性，当属性或者元素过多时，会报“well-formedness<br />
error”这样的警告信息。如果业务逻辑确实需要设计一个繁琐的POJO，可以通过设置MessageProperties.XML_SECURITY_DISABLE参数值为TRUE来屏蔽。服务器端和客户端，示例代码如下。</p>
<p>@ApplicationPath("/*")</p>
<p>public class XXXResourceConfig extends<br />
ResourceConfig {</p>
<p>   <br />
public XXXResourceConfig() {</p>
<p>      <br />
packages("xxx.yyy.zzz");</p>
<p>      <br />
property(MessageProperties.XML_SECURITY_DISABLE, Boolean.TRUE);</p>
<p>    }</p>
<p>}</p>
<p>ClientConfig config = new ClientConfig();</p>
<p>config.property(MessageProperties.XML_SECURITY_DISABLE,<br />
Boolean.TRUE);</p>
<p>2.3.6　JSON类型</p>
<p>JSON类型已经成为Ajax技术中数据传输的实际标准。Jersey提供了4种处理JSON数据的媒体包。表2-6展示了4种技术对3种解析流派（基于POJO的JSON绑定、基于JAXB的JSON绑定以及低级的（逐字的）JSON解析和处理）的支持情况。MOXy和Jackon的处理方式相同，它们都不支持以JSON对象方式解析JSON数据，而是以绑定方式解析。Jettison支持以JSON对象方式解析JSON数据，同时支持JAXB方式的绑定。JSON-P就只支持JSON对象方式解析这种方式了。</p>
<p>表2-6　Jersey对JSON的处理方式列表</p>
<p>解析方式\JSON支持包  MOXy       JSON-P     Jackson    Jettison</p>
<p>POJO-based JSON Binding        是     否     是     否</p>
<p>JAXB-based JSON Binding        是     否     是     是</p>
<p>Low-level JSON parsing &amp; processing      否     是     否     是</p>
<p> </p>
<p>下面将介绍MOXy、SON-P、Jackson和Jettison这4种Jersey支持的JSON处理技术在REST式的Web服务开发中的使用。</p>
<p>1. 使用MOXy处理JSON</p>
<p>MOXy是EclipseLink项目的一个模块，其官方网站http://www.eclipse.org/eclipselink/moxy.php宣称EclipseLink的MOXy组件是使用JAXB和SDO作为XML绑定的技术基础。MOXy实现了JSR 222标准（JAXB2.2）和JSR 235标准（SDO2.1.1），这使得使用MOXy的Java开发者能够高效地完成Java类和XML的绑定，所要花费的只是使用注解来定义它们之间的对应关系。同时，MOXy实现了JSR-353标准（Java API for Processing JSON1.0），以JAXB为基础来实现对JSR353的支持。下面开始讲述使用MOXy实现在REST应用中解析JSON的完整过程。</p>
<p>阅读指南</p>
<p>2.3.6节的MOXy示例源代码地址：https://github.com/feuyeux/jax-rs2-guide-II/tree/master/2.3.6-1.simple-service-moxy。</p>
<p>（1）定义依赖</p>
<p>MOXy是Jersey默认的JSON解析方式，可以在项目中添加MOXy的依赖包来使用MOXy。</p>
<p>&lt;dependency&gt;</p>
<p>   <br />
&lt;groupId&gt;org.glassfish.jersey.media&lt;/groupId&gt;</p>
<p>   <br />
&lt;artifactId&gt;jersey-media-moxy&lt;/artifactId&gt;</p>
<p>&lt;/dependency&gt;</p>
<p>（2）定义Application</p>
<p>使用Servlet3可以不定义web.xml配置，否则请参考1.6节的讲述。</p>
<p>MOXy的Feature接口实现类是MoxyJsonFeature，默认情况下，Jersey对其自动探测，无须在Applicaion类或其子类显式注册该类。如果不希望Jersey这种默认行为，可以通过设置如下属性来禁用自动探测：CommonProperties.MOXY_JSON_FEATURE_DISABLE两端禁用，ServerProperties.MOXY_JSON_FEATURE_DISABLE服务器端禁用，ClientProperties.MOXY_JSON_FEATURE_DISABLE客户端禁用。</p>
<p>@ApplicationPath("/api/*")</p>
<p>public class JsonResourceConfig extends<br />
ResourceConfig {</p>
<p>   <br />
public JsonResourceConfig() {</p>
<p>       <br />
register(BookResource.class);</p>
<p>       <br />
//property(org.glassfish.jersey.CommonProperties.MOXY_JSON_FEATURE_DISABLE,<br />
true);</p>
<p>    }</p>
<p>}</p>
<p>（3）定义资源类</p>
<p>接下来，我们定义一个图书资源类BookResource，并在其中实现表述媒体类型为JSON的资源方法getBooks()。支持JSON格式的表述的资源类定义如下。</p>
<p>@Path("books")</p>
<p>//关注点1：@Produces注解和@Consumes注解上移到接口</p>
<p>@Consumes(MediaType.APPLICATION_JSON)</p>
<p>@Produces(MediaType.APPLICATION_JSON)</p>
<p>public class BookResource {</p>
<p>   <br />
private static final HashMap&lt;Long, Book&gt; memoryBase;</p>
<p>...</p>
<p>   <br />
@GET</p>
<p>   <br />
//关注点2：实现类方法无需再定义@Produces注解和@Consumes注解</p>
<p>   <br />
public Books getBooks() {</p>
<p>       <br />
final List&lt;Book&gt; bookList = new ArrayList&lt;&gt;();</p>
<p>       <br />
final Set&lt;Map.Entry&lt;Long, Book&gt;&gt; entries = BookResource.memoryBase.entrySet();</p>
<p>       <br />
final Iterator&lt;Entry&lt;Long, Book&gt;&gt; iterator =<br />
entries.iterator();</p>
<p>       <br />
while (iterator.hasNext()) {</p>
<p>           <br />
final Entry&lt;Long, Book&gt; cursor = iterator.next();</p>
<p>           <br />
BookResource.LOGGER.debug(cursor.getKey());</p>
<p>            bookList.add(cursor.getValue());</p>
<p>       <br />
}</p>
<p>       <br />
final Books books = new Books(bookList);</p>
<p>       <br />
BookResource.LOGGER.debug(books);</p>
<p>       <br />
return books;</p>
<p>    }</p>
<p>}</p>
<p>在这段代码中，资源类BookResource定义了@Consumes(MediaType.APPLICATION_JSON)和@Produces(MediaType.APPLICATION_JSON)，表示该类的所有资源方法都使用MediaType.APPLICATION_JSON类型作为请求和响应的数据类型，见关注点1；因此，getBooks()方法上无须再定义@Consumes和@Produces，见关注点2。</p>
<p>如果REST应用处于多语言环境中，不要忘记统一开放接口的字符编码；如果统一开放接口同时供前端jsonp使用，不要忘记添加相关媒体类型，示例如下。</p>
<p>@Produces({"application/x-javascript;charset=UTF-8",<br />
"application/json;charset=UTF-8"})</p>
<p>在这段代码中，REST API将支持jsonp、json，并且统一字符编码为UTF-8。</p>
<p>（4）单元测试</p>
<p>JSON处理的单元测试主要关注请求的响应中JSON数据的可用性、完整性和一致性。在本章使用的单元测试中，验证JSON处理无误的标准是测试的返回值是一个Java类型的实体类实例，整个请求处理过程中没有异常发生，测试代码如下。</p>
<p>public class JsonTest extends JerseyTest {</p>
<p>   <br />
private final static Logger LOGGER = Logger.getLogger(JsonTest.class);</p>
<p>@Override</p>
<p>   <br />
protected Application configure() {</p>
<p>       <br />
enable(TestProperties.LOG_TRAFFIC);</p>
<p>       <br />
enable(TestProperties.DUMP_ENTITY);</p>
<p>       <br />
return new ResourceConfig(BookResource.class);</p>
<p>    }</p>
<p>   <br />
@Test</p>
<p>   <br />
public void testGettingBooks() {</p>
<p>//关注点1：在请求中定义媒体类型为JSON</p>
<p>       <br />
Books books =<br />
target("books").request(MediaType.APPLICATION_JSON_TYPE).</p>
<p>get(Books.class);</p>
<p>        for (Book book : books.getBookList()) {</p>
<p>           <br />
LOGGER.debug(book.getBookName());</p>
<p>       <br />
}</p>
<p>    }</p>
<p>}</p>
<p>在这段代码中，测试方法testGettingBooks()定义了请求资源的数据类型为MediaType.APPLICATION_JSON_TYPE来匹配服务器端提供的REST API，其作用是定义请求的媒体类型为JSON格式的，见关注点1。</p>
<p>（5）集成测试</p>
<p>除了单元测试，我们使用cURL来做集成测试。首先启动本示例，然后输入如下所示的命令。</p>
<p>curl<br />
http://localhost:8080/simple-service-moxy/api/books</p>
<p>curl -H "Content-Type:<br />
application/json" http://localhost:8080/simple-service-moxy/api/books</p>
<p>返回JSON格式的数据如下。</p>
<p>{"bookList":{"book":[{"bookId":1,"bookName":"JSF2和RichFaces4使用指南","publisher":"电子工业出版社","isbn":"9787121177378","publishTime":"2012-09-01"},{"bookId":2,"bookName":"Java<br />
Restful Web Services实战","publisher":"机械工业出版社","isbn":"9787111478881","publishTime":"2014-09-01"},{"bookId":3,"bookName":"Java<br />
EE 7 精髓","publisher":"人民邮电出版社","isbn":"9787115375483","publishTime":"2015-02-01"},{"bookId":4,"bookName":"Java<br />
Restful Web Services实战II","publisher":"机械工业出版社"}]}}</p>
<p>2. 使用JSON-P处理JSON</p>
<p>JSON-P的全称是 Java API for<br />
JSON Processing（Java的JSON处理API），而不是JSON with padding（JSONP），两者只是名称相仿，用途大相径庭。JSON-P是JSR 353标准规范，用于统一Java处理JSON格式数据的API，其生产和消费的JSON数据以流的形式，类似StAX处理XML，并为JSON数据建立Java对象模型，类似DOM。而JSONP是用于异步请求中传递脚本的回调函数来解决跨域问题。下面开始讲述使用JSON-P实现在REST应用中解析JSON的完整过程。</p>
<p>阅读指南</p>
<p>2.3.6节的JSON-P示例源代码地址：https://github.com/feuyeux/jax-rs2-guide-II/tree/master/2.3.6-2.simple-service-jsonp。</p>
<p>（1）定义依赖</p>
<p>使用JSON-P方式处理JSON类型的数据，需要在项目的Maven配置中声明如下依赖。</p>
<p>&lt;dependency&gt;</p>
<p>   <br />
&lt;groupId&gt;org.glassfish.jersey.media&lt;/groupId&gt;</p>
<p>   <br />
&lt;artifactId&gt;jersey-media-json-processing&lt;/artifactId&gt;</p>
<p>&lt;/dependency&gt;</p>
<p>（2）定义Application</p>
<p>使用JSON-P的应用，默认不需要在其Application中注册JsonProcessingFeature，除非使用了如下设置。依次用于在服务器和客户端两侧去活JSON-P功能、在服务器端去活JSON-P功能、在客户端去活JSON-P功能。</p>
<p>CommonProperties.JSON_PROCESSING_FEATURE_DISABLE</p>
<p>ServerProperties.JSON_PROCESSING_FEATURE_DISABLE</p>
<p>ClientProperties.JSON_PROCESSING_FEATURE_DISABLE</p>
<p>JsonGenerator.PRETTY_PRINTING属性用于格式化JSON数据的输出，当属性值为TRUE时，MesageBodyReader和MessageBodyWriter实例会对JSON数据进行额外处理，使得JSON数据可以格式化打印。该属性的设置在Application中，见关注点1，示例代码如下。</p>
<p>@ApplicationPath("/api/*")</p>
<p>public class JsonResourceConfig extends<br />
ResourceConfig {</p>
<p>   <br />
public JsonResourceConfig() {</p>
<p>       <br />
register(BookResource.class);</p>
<p>//关注点1：配置JSON格式化输出</p>
<p>       <br />
property(JsonGenerator.PRETTY_PRINTING, true);</p>
<p>    }</p>
<p>}</p>
<p>（3）定义资源类</p>
<p>资源类BookResource同上例一样定义了类级别的@Consumes和@Produces，媒体格式为MediaType.APPLICATION_JSON，资源类BookResource的示例代码如下。</p>
<p>@Path("books")</p>
<p>@Consumes(MediaType.APPLICATION_JSON)</p>
<p>@Produces(MediaType.APPLICATION_JSON)</p>
<p>public class BookResource {</p>
<p>...</p>
<p>   <br />
static {</p>
<p>       <br />
memoryBase = com.google.common.collect.Maps.newHashMap();</p>
<p>       <br />
//关注点1：构建JsonObjectBuilder实例</p>
<p>       <br />
JsonObjectBuilder jsonObjectBuilder = Json.createObjectBuilder();</p>
<p>       <br />
//关注点2：构建JsonObject实例</p>
<p>       <br />
JsonObject newBook1 = jsonObjectBuilder.add("bookId", 1)</p>
<p>           <br />
.add("bookName", "Java Restful Web Services实战")</p>
<p>           <br />
.add("publisher", "机械工业出版社")</p>
<p>            .add("isbn",<br />
"9787111478881")</p>
<p>           <br />
.add("publishTime", "2014-09-01")</p>
<p>           <br />
.build();</p>
<p>...</p>
<p>    }</p>
<p>   <br />
@GET</p>
<p>   <br />
public JsonArray getBooks() {</p>
<p>       <br />
//关注点3：构建JsonArrayBuilder实例</p>
<p>       <br />
final JsonArrayBuilder arrayBuilder = Json.createArrayBuilder();</p>
<p>       <br />
final Set&lt;Map.Entry&lt;Long, JsonObject&gt;&gt; entries =</p>
<p>       <br />
BookResource.memoryBase.entrySet();</p>
<p>       <br />
final Iterator&lt;Entry&lt;Long, JsonObject&gt;&gt; iterator =<br />
entries.iterator();</p>
<p>       <br />
while (iterator.hasNext()) {</p>
<p>...</p>
<p>       <br />
}</p>
<p>       <br />
//关注点4：构建JsonArray实例</p>
<p>       <br />
JsonArray result = arrayBuilder.build();</p>
<p>       <br />
return result;</p>
<p>    }</p>
<p>}</p>
<p>在这段代码中，JsonObjectBuilder用于构造JSON对象，见关注点1；JsonArrayBuilder用于构造JSON数组对象，见关注点2；JsonObject是JSON-P定义的JSON对象类，见关注点3；JsonArray是JSON数组类，见关注点4。</p>
<p>（4）单元测试</p>
<p>JSON-P示例的单元测试需要关注JSON-P定义的JSON类型，测试验收标准在前一小节MOXy的单元测试中已经讲述，示例代码如下。</p>
<p>public class JsonTest extends JerseyTest {</p>
<p>   <br />
private final static Logger LOGGER = Logger.getLogger(JsonTest.class);</p>
<p>@Override</p>
<p>   <br />
protected Application configure() {</p>
<p>       <br />
enable(TestProperties.LOG_TRAFFIC);</p>
<p>       <br />
enable(TestProperties.DUMP_ENTITY);</p>
<p>       <br />
return new ResourceConfig(BookResource.class);</p>
<p>    }</p>
<p>   <br />
@Test</p>
<p>   <br />
public void testGettingBooks() {</p>
<p>//关注点1：请求的响应类型为JsonArray</p>
<p>       <br />
JsonArray books = target("books").request(MediaType.APPLICATION_JSON_TYPE).</p>
<p>get(JsonArray.class);</p>
<p>       <br />
for (JsonValue jsonValue : books) {</p>
<p>//关注点2：强转JsonValue为JsonObject</p>
<p>           <br />
JsonObject book = (JsonObject) jsonValue;</p>
<p>           <br />
LOGGER.debug(book.getString("bookName"));//关注点3：打印输出测试结果</p>
<p>     <br />
  }</p>
<p>    }</p>
<p>}</p>
<p>在这段代码片段中，JsonArray是getBooks()方法的返回类型，get()请求发出后，服务器端对应的方法是getBooks()方法，见关注点1；JsonValue类型是一种抽象化的JSON数据类型，此处类型强制转化为JsonObject，见关注点2；getString()方法是将JsonObject对象的某个字段以字符串类型返回，见关注点3。</p>
<p>（5）集成测试</p>
<p>使用cURL对本示例进行集成测试的结果如下所示，JSON数据结果可以格式化打印输出。</p>
<p>curl<br />
http://localhost:8080/simple-service-jsonp/api/books</p>
<p> </p>
<p>[</p>
<p>    {</p>
<p>       <br />
"bookId":1,</p>
<p>       <br />
"bookName":"Java Restful Web Services实战",</p>
<p>       <br />
"publisher":"机械工业出版社",</p>
<p>       <br />
"isbn":"9787111478881",</p>
<p>       <br />
"publishTime":"2014-09-01"</p>
<p>   <br />
},</p>
<p>    {</p>
<p>      <br />
 "bookId":2,</p>
<p>       <br />
"bookName":"JSF2和RichFaces4使用指南",</p>
<p>       <br />
"publisher":"电子工业出版社",</p>
<p>       <br />
"isbn":"9787121177378",</p>
<p>       <br />
"publishTime":"2012-09-01"</p>
<p>   <br />
},</p>
<p>    {</p>
<p>       <br />
"bookId":3,</p>
<p>       <br />
"bookName":"Java EE 7精髓",</p>
<p>       <br />
"publisher":"人民邮电出版社",</p>
<p>        "isbn":"9787115375483",</p>
<p>       <br />
"publishTime":"2015-02-01"</p>
<p>   <br />
},</p>
<p>    {</p>
<p>       <br />
"bookId":4,</p>
<p>       <br />
"bookName":"Java Restful Web Services实战II",</p>
<p>       <br />
"publisher":"机械工业出版社"</p>
<p>    }</p>
<p>]</p>
<p>curl<br />
http://localhost:8080/simple-service-jsonp/api/books/book?id=1</p>
<p>{</p>
<p>   <br />
"bookId":1,</p>
<p>   <br />
"bookName":"Java Restful Web Services实战",</p>
<p>   <br />
"publisher":"机械工业出版社",</p>
<p>   <br />
"isbn":"9787111478881",</p>
<p>   <br />
"publishTime":"2014-09-01"</p>
<p>}</p>
<p>curl -H "Content-Type:<br />
application/json" -X POST \</p>
<p>-d<br />
"{\"bookName\":\"abc\",\"publisher\":\"me\"}"<br />
\</p>
<p>http://localhost:8080/simple-service-jsonp/api/books</p>
<p> </p>
<p>{</p>
<p>   <br />
"bookId":23670621181527,</p>
<p>   <br />
"bookName":"abc",</p>
<p>   <br />
"publisher":"me"</p>
<p>}</p>
<p>3.使用Jackson处理JSON</p>
<p>Jackson是一种流行的JSON支持技术，其源代码托管于Github，地址是：https://github.com/FasterXML/jackson。Jackson提供了3种JSON解析方式。</p>
<p>第一种是基于流式API的增量式解析/生成JSON的方式，读写JSON内容的过程是通过离散事件触发的，其底层基于StAX API读取JSON使用org.codehaus.jackson.JsonParser，写入JSON使用org.codehaus.jackson.JsonGenerator。</p>
<p>第二种是基于树型结构的内存模型，提供一种不变式的JsonNode内存树模型，类似DOM树。</p>
<p>第三种是基于数据绑定的方式，org.codehaus.jackson.map.ObjectMapper解析，使用JAXB的注解。</p>
<p>下面开始讲述使用Jackson实现在REST应用中解析JSON的完整过程。</p>
<p>阅读指南</p>
<p>2.3.6节的Jackson示例源代码地址：https://github.com/feuyeux/jax-rs2-guide-II/tree/master/2.3.6-3.simple-service-jackson。</p>
<p>（1）定义依赖</p>
<p>使用Jackson方式处理JSON类型的数据，需要在项目的Maven配置中声明如下依赖。</p>
<p>&lt;dependency&gt;</p>
<p>   <br />
&lt;groupId&gt;org.glassfish.jersey.media&lt;/groupId&gt;</p>
<p>   <br />
&lt;artifactId&gt;jersey-media-json-jackson&lt;/artifactId&gt;</p>
<p>&lt;/dependency&gt;</p>
<p>（2）定义Application</p>
<p>使用Jackson的应用，需要在其Application中注册JacksonFeature。同时，如果有必要根据不同的实体类做详细的解析，可以注册ContextResolver的实现类，示例代码如下。</p>
<p>@ApplicationPath("/api/*")</p>
<p>public class JsonResourceConfig extends<br />
ResourceConfig {</p>
<p>   <br />
public JsonResourceConfig() {</p>
<p>       <br />
register(BookResource.class);</p>
<p>       <br />
register(JacksonFeature.class);</p>
<p>       <br />
//关注点1：注册ContextResolver的实现类JsonContextProvider</p>
<p>       <br />
register(JsonContextProvider.class);</p>
<p>    }</p>
<p>}</p>
<p>在这段代码中，注册了ContextResolver的实现类JsonContextProvider，用于提供JSON数据的上下文，见关注点1。有关ContextResolver详细信息参考3.2节。</p>
<p>（3）定义POJO</p>
<p>本例定义了3种不同方式的POJO，以演示Jackson处理JSON的多种方式。分别是JsonBook、JsonHybridBook和JsonNoJaxbBook。第一种方式是仅用JAXB注解的普通的POJO，示例类JsonBook如下。</p>
<p>@XmlRootElement</p>
<p>@XmlType(propOrder = {"bookId",<br />
"bookName", "chapters"})</p>
<p>public class JsonBook {</p>
<p>   <br />
private String[] chapters;</p>
<p>   <br />
private String bookId;</p>
<p>   <br />
private String bookName;</p>
<p> </p>
<p>   <br />
public JsonBook() {</p>
<p>       <br />
bookId = "1";</p>
<p>       <br />
bookName = "Java Restful Web Services实战";</p>
<p>       <br />
chapters = new String[0];</p>
<p>    }</p>
<p>...</p>
<p>}</p>
<p>第二种方式是将JAXB的注解和Jackson提供的注解混合使用的POJO，示例类JsonHybridBook如下。</p>
<p>//关注点1：使用JAXB注解</p>
<p>@XmlRootElement</p>
<p>public class JsonHybridBook {</p>
<p>   <br />
//关注点2：使用Jackson注解</p>
<p>   <br />
@JsonProperty("bookId")</p>
<p>   <br />
private String bookId;</p>
<p> </p>
<p>   <br />
@JsonProperty("bookName")</p>
<p>   <br />
private String bookName;</p>
<p> </p>
<p>   <br />
public JsonHybridBook() {</p>
<p>       <br />
bookId = "2";</p>
<p>       <br />
bookName = "Java Restful Web Services实战";</p>
<p>    }</p>
<p>}</p>
<p>在这段代码中，分别使用了JAXB的注解javax.xml.bind.annotation.XmlRootElement，见关注点1，和Jackson的注解org.codehaus.jackson.annotate.JsonProperty，见关注点2，定义XML根元素和XML属性。</p>
<p>第三种方式是不使用任何注解的POJO，示例类JsonNoJaxbBook如下。</p>
<p>public class JsonNoJaxbBook {</p>
<p>   <br />
private String[] chapters;</p>
<p>   <br />
private String bookId;</p>
<p>   <br />
private String bookName;</p>
<p>   <br />
public JsonNoJaxbBook() {</p>
<p>       <br />
bookId = "3";</p>
<p>       <br />
bookName = "Java Restful Web Services使用指南";</p>
<p>       <br />
chapters = new String[0];</p>
<p>    }</p>
<p>...</p>
<p>}</p>
<p>这样的3种POJO如何使用Jackson处理来处理呢？我们继续往下看。</p>
<p>（4）定义资源类</p>
<p>资源类BookResource用于演示Jackson对上述3种不同POJO的支持，示例代码如下。</p>
<p>@Path("books")</p>
<p>@Consumes(MediaType.APPLICATION_JSON)</p>
<p>@Produces(MediaType.APPLICATION_JSON)</p>
<p>public class BookResource {</p>
<p>   <br />
@Path("/emptybook")</p>
<p>   <br />
@GET</p>
<p>//关注点1：支持第一种方式的POJO类型</p>
<p>   <br />
public JsonBook getEmptyArrayBook() {</p>
<p>return new JsonBook();</p>
<p>    }</p>
<p>   <br />
@Path("/hybirdbook")</p>
<p>   <br />
@GET</p>
<p>//关注点2：支持第二种方式的POJO类型</p>
<p>   <br />
public JsonHybridBook getHybirdBook() {</p>
<p>return new JsonHybridBook();</p>
<p>    }</p>
<p>   <br />
@Path("/nojaxbbook")</p>
<p>   <br />
@GET</p>
<p>//关注点3：支持第三种方式的POJO类型</p>
<p>   <br />
public JsonNoJaxbBook getNoJaxbBook() {</p>
<p>return new JsonNoJaxbBook();</p>
<p>    }</p>
<p>……</p>
<p>在这段代码中，资源类BookResource定义了路径不同的3个GET方法，返回类型分别对应上述的3种POJO，见关注点1到3。有了这样的资源类，就可以向其发送GET请求，并获取不同类型的JSON数据，以研究Jackson是如何支持这3种POJO的JSON转换。</p>
<p>（5）上下文解析实现类</p>
<p>JsonContextProvider是ContextResolver（上下文解析器）的实现类，其作用是根据上下文提供的POJO类型，分别提供两种解析方式。第一种是默认的方式，第二种是混合使用Jackson和Jaxb。两种解析方式的示例代码如下。</p>
<p>@Provider</p>
<p>public class JsonContextProvider implements<br />
ContextResolver&lt;ObjectMapper&gt; {</p>
<p>   <br />
final ObjectMapper d;</p>
<p>   <br />
final ObjectMapper c;</p>
<p>   <br />
public JsonContextProvider() {</p>
<p>       <br />
//关注点1：实例化ObjectMapper</p>
<p>       <br />
d = createDefaultMapper();</p>
<p>        c = createCombinedMapper();</p>
<p>    }</p>
<p>   <br />
private static ObjectMapper createCombinedMapper() {</p>
<p>       <br />
Pair ps = createIntrospector();</p>
<p>       <br />
ObjectMapper result = new ObjectMapper();</p>
<p>       <br />
result.setDeserializationConfig(</p>
<p>       <br />
result.getDeserializationConfig().withAnnotationIntrospector(ps));</p>
<p>       <br />
result.setSerializationConfig(</p>
<p>       <br />
result.getSerializationConfig().withAnnotationIntrospector(ps));</p>
<p>       <br />
return result;</p>
<p>    }</p>
<p>   <br />
private static ObjectMapper createDefaultMapper() {</p>
<p>       <br />
ObjectMapper result = new ObjectMapper();</p>
<p>       <br />
result.configure(Feature.INDENT_OUTPUT, true);</p>
<p>       <br />
return result;</p>
<p>    }</p>
<p>   <br />
private static Pair createIntrospector() {</p>
<p>       <br />
AnnotationIntrospector p = new JacksonAnnotationIntrospector();</p>
<p>       <br />
AnnotationIntrospector s = new JaxbAnnotationIntrospector();</p>
<p>       <br />
return new Pair(p, s);</p>
<p>    }</p>
<p>   <br />
@Override    public ObjectMapper<br />
getContext(Class&lt;\?&gt; type) {</p>
<p>//关注点2：判断POJO类型返回相应的ObjectMapper实例</p>
<p>       <br />
if (type == JsonHybridBook.class) {</p>
<p>            return c;</p>
<p>       <br />
} else {</p>
<p>           <br />
return d;</p>
<p>       <br />
}</p>
<p>    }</p>
<p>}</p>
<p>在这段代码中，JsonContextProvider定义并实例化了两种类型ObjectMapper，见关注点1；在实现接口方法getContext()中，通过判断当前POJO的类型，返回两种ObjectMapper实例之一，见关注点2。通过这样的实现，当流程获取JSON上下文时，既可使用Jackson依赖包完成对相关POJO的处理。</p>
<p>（6）单元测试</p>
<p>单元测试类BookResourceTest的目的是对支持上述3种POJO的资源地址发起请求并测试结果，示例如下。</p>
<p>public class BookResourceTest extends<br />
JerseyTest {</p>
<p>   <br />
private static final Logger LOGGER =<br />
Logger.getLogger(BookResourceTest.class);</p>
<p>   <br />
WebTarget booksTarget = target("books");</p>
<p>   <br />
@Override</p>
<p>   <br />
protected ResourceConfig configure() {</p>
<p>//关注点1：服务器端配置</p>
<p>       <br />
enable(TestProperties.LOG_TRAFFIC);</p>
<p>       <br />
enable(TestProperties.DUMP_ENTITY);</p>
<p>       <br />
ResourceConfig resourceConfig = new ResourceConfig(BookResource.class);</p>
<p>//关注点2：注册JacksonFeature</p>
<p>       <br />
resourceConfig.register(JacksonFeature.class);</p>
<p>       <br />
return resourceConfig;</p>
<p>    }</p>
<p>   <br />
@Override</p>
<p>   <br />
protected void configureClient(ClientConfig config) {</p>
<p>//关注点3：注册JacksonFeature</p>
<p>       <br />
config.register(new JacksonFeature());</p>
<p>       <br />
config.register(JsonContextProvider.class);</p>
<p>    }</p>
<p>   <br />
@Test</p>
<p>//关注点4：测试出参为JsonBook类型的资源方法</p>
<p>   <br />
public void testEmptyArray() {</p>
<p>       <br />
JsonBook book =<br />
booksTarget.path("emptybook").request(MediaType.APPLICATION_JSON).get(JsonBook.class);</p>
<p>       <br />
LOGGER.debug(book);</p>
<p>    }</p>
<p>   <br />
@Test</p>
<p>//关注点5：测试出参为JsonHybridBook类型的资源方法</p>
<p>   <br />
public void testHybrid() {</p>
<p>       <br />
JsonHybridBook book =<br />
booksTarget.path("hybirdbook").request(MediaType</p>
<p>.APPLICATION_JSON).get(JsonHybridBook.class);</p>
<p>       <br />
LOGGER.debug(book);</p>
<p>    }</p>
<p>   <br />
@Test</p>
<p>//关注点6：测试出参为JsonNoJaxbBook类型的资源方法</p>
<p>   <br />
public void testNoJaxb() {</p>
<p>       <br />
JsonNoJaxbBook book =<br />
booksTarget.path("nojaxbbook").request(MediaType.</p>
<p>APPLICATION_JSON).get(JsonNoJaxbBook.class);</p>
<p>       <br />
LOGGER.debug(book);</p>
<p>    }</p>
<p>……</p>
<p>在这段代码中，首先要在服务器端注册支持Jackson功能，见关注点2；同时在客户端也要注册支持Jackson功能并注册JsonContextProvider，见关注点3；该测试类包含了用于测试3种类型POJO的测试用例，见关注点4到6；注意，configure()方法是覆盖测试服务器实例行为，configureClient()方法是覆盖测试客户端实例行为，见关注点1。</p>
<p>（7）集成测试</p>
<p>使用cURL对本例进行集成测试，结果如下所示。</p>
<p>curl http://localhost:8080/simple-service-jackson/api/books</p>
<p> </p>
<p>{</p>
<p> <br />
"bookList" : [ {</p>
<p>   <br />
"bookId" : 1,</p>
<p>   <br />
"bookName" : "JSF2和RichFaces4使用指南",</p>
<p>   <br />
"isbn" : "9787121177378",</p>
<p>   <br />
"publisher" : "电子工业出版社",</p>
<p>   <br />
"publishTime" : "2012-09-01"</p>
<p>  },<br />
{</p>
<p>   <br />
"bookId" : 2,</p>
<p>   <br />
"bookName" : "Java Restful Web Services实战",</p>
<p>   <br />
"isbn" : "9787111478881",</p>
<p>   <br />
"publisher" : "机械工业出版社",</p>
<p>   <br />
"publishTime" : "2014-09-01"</p>
<p>  },<br />
{</p>
<p>   <br />
"bookId" : 3,</p>
<p>   <br />
"bookName" : "Java EE 7 精髓",</p>
<p>   <br />
"isbn" : "9787115375483",</p>
<p>   <br />
"publisher" : "人民邮电出版社",</p>
<p>   <br />
"publishTime" : "2015-02-01"</p>
<p>  },<br />
{</p>
<p>   <br />
"bookId" : 4,</p>
<p>   <br />
"bookName" : "Java Restful Web Services实战II",</p>
<p>   <br />
"isbn" : null,</p>
<p>   <br />
"publisher" : "机械工业出版社",</p>
<p>   <br />
"publishTime" : null</p>
<p>  } ]</p>
<p>}</p>
<p>curl<br />
http://localhost:8080/simple-service-jackson/api/books/emptybook</p>
<p> </p>
<p>{</p>
<p> <br />
"chapters" : [ ],</p>
<p> <br />
"bookId" : "1",</p>
<p> <br />
"bookName" : "Java Restful Web Services实战"</p>
<p>}</p>
<p>curl<br />
http://localhost:8080/simple-service-jackson/api/books/hybirdbook</p>
<p> </p>
<p>{"JsonHybridBook":{"bookId":"2","bookName":"Java<br />
Restful Web Services实战"}}</p>
<p>curl http://localhost:8080/simple-service-jackson/api/books/nojaxbbook</p>
<p> </p>
<p>{</p>
<p> <br />
"chapters" : [ ],</p>
<p> <br />
"bookId" : "3",</p>
<p> <br />
"bookName" : "Java Restful Web Services实战"</p>
<p>}</p>
<p>4. 使用Jettison处理JSON</p>
<p>Jettison是一种使用StAX来解析JSON的实现。项目地址是：http://jettison.codehaus.org。Jettison项目起初用于为CXF提供基于JSON的Web服务，在XStream的Java对象的序列化中也使用了Jettison。Jettison支持两种JSON映射到XML的方式。Jersey默认使用MAPPED方式，另一种叫做BadgerFish方式。</p>
<p>下面开始讲述使用Jettison实现在REST应用中解析JSON的完整过程。</p>
<p>阅读指南</p>
<p>2.3.6节的Jettison示例源代码地址：https://github.com/feuyeux/jax-rs2-guide-II/tree/master/2.3.6-4.simple-service-jettison。</p>
<p>（1）定义依赖</p>
<p>使用Jettison方式处理JSON类型的数据，需要在项目的Maven配置中声明如下依赖。</p>
<p>&lt;dependency&gt;</p>
<p>   <br />
&lt;groupId&gt;org.glassfish.jersey.media&lt;/groupId&gt;</p>
<p>   <br />
&lt;artifactId&gt;jersey-media-json-jettison&lt;/artifactId&gt;</p>
<p>&lt;/dependency&gt;</p>
<p>（2）定义Application</p>
<p>使用Jettison的应用，需要在其Application中注册JettisonFeature。同时，如果有必要根据不同的实体类做详细的解析，可以注册ContextResolver的实现类，示例代码如下。</p>
<p>@ApplicationPath("/api/*")</p>
<p>public class JsonResourceConfig extends<br />
ResourceConfig {</p>
<p>   <br />
public JsonResourceConfig() {</p>
<p>       <br />
register(BookResource.class);</p>
<p>       <br />
//关注点1：注册JettisonFeature和ContextResolver的实现类JsonContextResolver</p>
<p>       <br />
register(JettisonFeature.class);</p>
<p>       <br />
register(JsonContextResolver.class);</p>
<p>    }</p>
<p>}</p>
<p>在这段代码中，注册了Jettison功能JettisonFeature和ContextResolver的实现类JsonContextResolver，以便使用Jettison处理JSON，见关注点1。</p>
<p>（3）定义POJO</p>
<p>本例定义了两个类名不同、内容相同的POJO（JsonBook和JsonBook2），用以演示Jettison对JSON数据以JETTISON_MAPPED（default notation）和BADGERFISH两种不同方式的处理情况。</p>
<p>@XmlRootElement</p>
<p>public class JsonBook {</p>
<p>   <br />
private String bookId;</p>
<p>   <br />
private String bookName;</p>
<p>   <br />
public JsonBook() {</p>
<p>       <br />
bookId = "1";</p>
<p>       <br />
bookName = "Java Restful Web Services实战";</p>
<p>    }</p>
<p>   <br />
...</p>
<p>}</p>
<p>（4）定义资源类</p>
<p>资源类BookResource为两种JSON方式提供了资源地址，示例如下。</p>
<p>@Path("books")</p>
<p>public class BookResource {</p>
<p>...</p>
<p>   <br />
@Path("/jsonbook")</p>
<p>   <br />
@GET</p>
<p>   <br />
//关注点1：返回类型为JsonBook的GET方法</p>
<p>   <br />
public JsonBook getBook() {</p>
<p>       <br />
final JsonBook book = new JsonBook();</p>
<p>       <br />
BookResource.LOGGER.debug(book);</p>
<p>       <br />
return book;</p>
<p>    }</p>
<p>   <br />
@Path("/jsonbook2")</p>
<p>   <br />
@GET</p>
<p>   <br />
//关注点2：返回类型为JsonBook2的GET方法</p>
<p>   <br />
public JsonBook2 getBook2() {</p>
<p>       <br />
final JsonBook2 book = new JsonBook2();</p>
<p>       <br />
BookResource.LOGGER.debug(book);</p>
<p>       <br />
return book;</p>
<p>    }</p>
<p> }</p>
<p>在这段代码中，资源类BookResource定义了路径不同的两个GET方法，返回类型分别是JsonBook和JsonBook2，见关注点1和2。有了这样的资源类，就可以向其发送GET请求，并获取不同类型的JSON数据，以研究Jettison是如何处理JETTISON_MAPPED和BADGERFISH两种不同格式的JSON数据的。</p>
<p>（5）上下文解析实现类</p>
<p>JsonContextResolver实现了ContextResolver接口，示例如下。</p>
<p>@Provider</p>
<p>public class JsonContextResolver implements<br />
ContextResolver&lt;JAXBContext&gt; {</p>
<p>   <br />
private final JAXBContext context1;</p>
<p>   <br />
private final JAXBContext context2;</p>
<p>   <br />
@SuppressWarnings("rawtypes")</p>
<p>   <br />
public JsonContextResolver() throws Exception {</p>
<p>       <br />
Class[] clz = new Class[]{JsonBook.class, JsonBook2.class, Books.class,<br />
Book.class};</p>
<p>       <br />
//关注点1：实例化JettisonJaxbContext</p>
<p>       <br />
this.context1 = new JettisonJaxbContext(JettisonConfig.DEFAULT, clz);</p>
<p>       <br />
this.context2 = new<br />
JettisonJaxbContext(JettisonConfig.badgerFish().build(), clz);</p>
<p>    }</p>
<p>   <br />
@Override</p>
<p>   <br />
public JAXBContext getContext(Class&lt;\?&gt; objectType) {</p>
<p>       <br />
//关注点2：判断POJO类型返回相应的JAXBContext实例</p>
<p>       <br />
if (objectType == JsonBook2.class) {</p>
<p>           <br />
return context2;</p>
<p>       <br />
} else {</p>
<p>           <br />
return context1;</p>
<p>       <br />
}</p>
<p>    }</p>
<p>}</p>
<p>在这段代码中，JsonContextResolver定义了两种JAXBContext分别使用MAPPED方式或者BadgerFish方式，见关注点1。这两种方式的参数信息来自Jettision依赖包的JettisonConfig类。在实现接口方法getContext()中，根据不同的POJO类型，返回两种JAXBContext实例之一，见关注点2。通过这样的实现，当流程获取JSON上下文时，既可使用Jettision依赖包完成对相关POJO的处理。</p>
<p>（6）单元测试</p>
<p>单元测试类BookResourceTest的目的是对支持上述两种JSON方式的资源地址发起请求并测试结果，示例如下。</p>
<p>public class BookResourceTest extends<br />
JerseyTest {</p>
<p>   <br />
private static final Logger LOGGER =<br />
Logger.getLogger(BookResourceTest.class);</p>
<p>   <br />
@Override</p>
<p>   <br />
protected ResourceConfig configure() {</p>
<p>       <br />
enable(TestProperties.LOG_TRAFFIC);</p>
<p>       <br />
enable(TestProperties.DUMP_ENTITY);</p>
<p>       <br />
ResourceConfig resourceConfig = new ResourceConfig(BookResource.class);</p>
<p>       <br />
//关注点1：注册JettisonFeature和JsonContextResolver</p>
<p>       <br />
resourceConfig.register(JettisonFeature.class);</p>
<p>       <br />
resourceConfig.register(JsonContextResolver.class);</p>
<p>       <br />
return resourceConfig;</p>
<p>    }</p>
<p>   <br />
@Override</p>
<p>   <br />
protected void configureClient(ClientConfig config) {</p>
<p>       <br />
//关注点2：注册JettisonFeature和JsonContextResolver</p>
<p>       <br />
config.register(new<br />
JettisonFeature()).register(JsonContextResolver.class);</p>
<p>    }</p>
<p>   <br />
@Test</p>
<p>   <br />
public void testJsonBook() {</p>
<p>       <br />
//关注点3：测试返回类型为JsonBook的GET方法</p>
<p>       <br />
JsonBook book = target("books").path("jsonbook")</p>
<p>       <br />
.request(MediaType.APPLICATION_JSON).get(JsonBook.class);</p>
<p>       <br />
LOGGER.debug(book);</p>
<p>       <br />
//{"jsonBook":{"bookId":1,"bookName":"abc"}}</p>
<p>    }</p>
<p>   <br />
@Test</p>
<p>   <br />
public void testJsonBook2() {</p>
<p>       <br />
//关注点4：测试返回类型为JsonBook2的GET方法</p>
<p>       <br />
JsonBook2 book = target("books").path("jsonbook2")</p>
<p>       <br />
.request(MediaType.APPLICATION_JSON).get(JsonBook2.class);</p>
<p>       <br />
LOGGER.debug(book);</p>
<p>       <br />
//{"jsonBook2":{"bookId":{"$":"1"},"bookName":{"$":"abc"}}}</p>
<p>    }</p>
<p>...</p>
<p>}</p>
<p>在这段代码中，首先要在服务器和客户端两侧注册Jettison功能和JsonContextResolver，见关注点1和2。该测试类包含了用于测试两种格式JSON数据的测试用例，见关注点3和4。</p>
<p>（7）集成测试</p>
<p>使用cURL对本例进行集成测试，结果如下所示。可以看到Mapped和Badgerfish两种方式的JSON数据内容不同。</p>
<p>curl<br />
http://localhost:8080/simple-service-jettison/api/books</p>
<p> </p>
<p>{"books":{"bookList":{"book":[{"@bookId":"1","@bookName":"JSF2和RichFaces4使用指南","@publisher":"电子工业出版社","isbn":9787121177378,"publishTime":"2012-09-01"},{"@bookId":"2","@bookName":"Java<br />
Restful Web Services实战","@publisher":"机械工业出版社","isbn":9787111478881,"publishTime":"2014-09-01"},{"@bookId":"3","@bookName":"Java<br />
EE 7 精髓","@publisher":"人民邮电出版社","isbn":9787115375483,"publishTime":"2015-02-01"},{"@bookId":"4","@bookName":"Java<br />
Restful Web Services实战II","@publisher":"机械工业出版社"}]}}}</p>
<p> </p>
<p>Jettison mapped notation</p>
<p>curl<br />
http://localhost:8080/simple-service-jettison/api/books/jsonbook</p>
<p> </p>
<p>{"jsonBook":{"bookId":1,"bookName":"Java<br />
Restful Web Services实战"}}</p>
<p> </p>
<p>Badgerfish notation</p>
<p> </p>
<p>curl<br />
http://localhost:8080/simple-service-jettison/api/books/jsonbook2</p>
<p>{"jsonBook2":{"bookId":{"$":"1"},"bookName":{"$":"Java<br />
Restful Web Services实战"}}}</p>
<p>最后简要介绍一下Atom类型。</p>
<p>Atom是一种基于XML的文档格式，该格式的标准定义在IETF RFC 4287（Atom Syndication Format，Atom联合格式），其推出的目的是用来替换RSS。AtomPub是基于Atom的发布协议，定义在IETF RFC 5023（Atom Publishing Protocol）。</p>
<p>Jersey2没有直接引入支持Atom格式的媒体包，但Jersey1.x中包含jersey-atom包。这说明Jersey的基本架构可以支持基于XML类型的数据，这种可插拔的媒体包支持对于Jersey本身更具灵活性，对使用Jersey的REST服务更具可扩展性。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-21 22:29:09</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%b5%8b%e8%af%95/" title="测试">测试</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/json/" title="json">json</a>, <a href="https://www.iamivan.net/tag/xml/" title="xml">xml</a>, <a href="https://www.iamivan.net/tag/web/" title="web">web</a>, <a href="https://www.iamivan.net/tag/request/" title="request">request</a>, <a href="https://www.iamivan.net/tag/class/" title="class">class</a>, <a href="https://www.iamivan.net/tag/%e5%8d%95%e5%85%83%e6%b5%8b%e8%af%95/" title="单元测试">单元测试</a>, <a href="https://www.iamivan.net/tag/service/" title="service">service</a>, <a href="https://www.iamivan.net/tag/logger/" title="logger">logger</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Java RESTful Web Service实战（第2版） 2.3　传输格式的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOljXQb.html" rel="bookmark">Java RESTful Web Service实战（第2版）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java核心技术系列 Java RESTful Web Service实战 (第2版) 韩陆 著 图书在版编目(CIP)数据 Java RESTful Web Service实战 / 韩陆著. -2版. -北京:机械工业出版社,2016.7 (Java核心技术系列) ISBN 978-7-111-54213-1 Ⅰ. J-   Ⅱ. 韩-   Ⅲ. JAVA语言-程序设计   Ⅳ. TP312 中国版本图书馆CIP数据核字(2016)第156331号 Java RESTful Web Servi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3W2OJb.html" rel="bookmark">Java RESTful Web Service实战（第2版） 导读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java核心技术系列 Java RESTful Web Service实战 (第2版) 韩陆 著   半年前初识韩陆的时候,我们就聊到他正在写的这本书,当得知我从2006年就参与了Apache CXF开发,他立即邀请我为他的新书写序,我也就欣然答应了. Apache CXF作为JAXWS以及JAX-RS规范的实现框架,已经成为很多Web服务开发者必选的开发框架.作为这一框架的开发维护者之一,我的日常工作经常需要熟悉这些JSR规范,并实现JSR所定义的API,解决最终用户的使用问题. 熟悉Java			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9xZZ4b.html" rel="bookmark">Java RESTful Web Service实战（第2版） 1&period;2　解读REST服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.2 解读REST服务 RESTful对应的中文是REST式的,RESTful Web Service的准确翻译应该是REST式的Web服务,我们通常简称为REST服务.RESTful的应用或者Web服务是最常见的两种REST式的项目部署.存在的方式.本节将介绍REST服务并对比其与传统Web Services的不同. 1.2.1 REST式的Web服务 RESTful Web Service是一种遵守REST式风格的Web服务.REST服务是一种ROA(Resource-Oriented A			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLoAo8M.html" rel="bookmark">Java RESTful Web Service实战（第2版） 1&period;3　解读JAX-RS标准</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.3 解读JAX-RS标准 JAX-RS是Java领域的REST式的Web服务的标准规范,是使用Java完成REST服务的基本约定. 1.3.1 JAX-RS2标准 Java领域中的Web Service是指实现SOAP协议的JAX-WS.直到Java EE 6(发布于2008年9月)通过JCP(Java Community Process)组织定义的JSR311(http://www.jcp.org/en/jsr/detail?id=311),才将REST在Java领域标准化. JSR311			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bod68VM.html" rel="bookmark">Java RESTful Web Service实战（第2版） 1&period;4　Jersey项目概要</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.4 Jersey项目概要 Jersey是JAX-RS标准的参考实现,是Java领域中最纯正的REST服务开发框架.本节将带读者走近Jersey的世界. Jersey项目是GlashFish项目的一个子项目,专门用来实现JAX-RS(JSR 311 &amp; JSR 339)标准,并提供了扩展特性. 1.4.1 获得Jersey Jersey项目的地址是https://jersey.java.net.该网站同时提供了JAX-RS和JAX-RS2两个并行版本,分别是JAX-RS1.1(截至本书发稿,最			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pm68Nlz.html" rel="bookmark">Java RESTful Web Service实战（第2版） 1&period;6　快速了解Java REST服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.6 快速了解Java REST服务 1.6.1 REST工程类型 在REST服务中,资源类是接收REST请求并完成响应的核心类,而资源类是由REST服务的&quot;提供者&quot;来调度的.这一概念类似其他框架中自定义的Servlet类,该类会将请求分派给指定的Controller/Action类来处理.本节将讲述REST中的这个提供者,即JAX-RS2中定义的Application以及Servlet. Application类在JAX-RS2(JSR339,详见参考资料)标准中定义为javax.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boRdy3z.html" rel="bookmark">Java RESTful Web Service实战（第2版） 1&period;5　快速实现Java REST服务</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.5 快速实现Java REST服务 本节包含两个Jersey实战示例,目的是让读者具备快速创建REST服务的能力. 在开始实战之前,首先需要读者确认你的环境是否已经安装了Java和Maven.这里使用Maven命令,示例如下. mvn -v   Apache Maven 3.3.3 (7994120775791599e205a5524ec3e0dfe41d4a06; 2015-04-22T19:57:37+08:00) Maven home: /usr/local/Cellar/maven/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boRkZ6z.html" rel="bookmark">Java RESTful Web Service实战（第2版） 1&period;7　Java领域的其他REST实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.7 Java领域的其他REST实现 Java领域存在很多REST实现,我们以是否遵循JAX-RS标准,将它们分为两组.前者是JAX-RS标准参考实现之外的厂商实现,后者要么是因为出现较JAX-RS标准早,要么干脆跳出了JAX-RS标准的定义,以自身框架一致性为目标,实现了一套独有的对REST开发的支持.本节将概括性地介绍这些实现工具,以便读者有所对比和选择. 1.7.1 JAX-RS的其他实现 JAX-RS标准发布后,诸多厂商推出了自己的基于JAX-RS标准的实现.其中最有影响力的当属来自J			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrWqQvp.html" rel="bookmark">Java RESTful Web Service实战（第2版） 1&period;9　本章小结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.9 本章小结 本章主要讲述了REST服务的概念和实战.先后解读了REST.REST服务.JAX-RS2标准中的重要概念,对JAX-RS2的参考实现项目Jersey进行了简单而全面的概述.随后讲述了如何快速创建REST应用和REST服务,介绍了基于JAX-RS2标准的其他项目和其他非JAX-RS2标准的.著名的Java项目. 通过阅读本章,读者可以清楚地掌握Java领域开发REST服务中的基本概念. 本章主要的知识点如下. REST是什么 一种架构风格. HTTP+URI+XML是REST的基			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8ZyNb.html" rel="bookmark" class="title">win8系统IE11如何降级到IE10浏览器？</a>
					<div>
						  win8系统IE11浏览器降级到IE10的设置方法: 1.首先从Win8左下角开始菜单中,找到&quot;控制面板&quot;然后点击进入; 2.进入控制面板之后,我们再选择点击进入&quot;W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJKK4b.html" rel="bookmark" class="title">php 合并字符串中连续空格</a>
					<div>
						php 实现清除文本字符串或html字符串中的多个连续空格的方法,具体代码如下: /** function 合并多个连续空格 */ function merge_spaces($string){ re ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDgP6p.html" rel="bookmark" class="title">怎样用ADO在SQL SERVER中建库，建表</a>
					<div>
						怎样用ADO在SQL SERVER中建库,建表 通过ADO可以访问SQL SERVER,并执行相应的SQL语句建库.建表,下面是SQL SERVER BOOKS ONLINE中的相关定义. 建表: C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqPmRb.html" rel="bookmark" class="title">纯编码实现数据库的建立或压缩</a>
					<div>
						编码|数据|数据库|压缩 &lt;% '#######以下是一个类文件,下面的注解是调用类的方法######################## '# 注意:如果系统不支持建立Scripting.Fi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6PwXz.html" rel="bookmark" class="title">秒收首页18天内收录内页日记</a>
					<div>
						首先我们会拿案例:不锈钢带这个网站来做具体操作实例 第一.用户分析篇 在做一个网站的时候首先要观察和统计用户需求才可以做一个好的站点对用户有用的站点,首先要了解这个行业或者这个关键词的用户需求是什么, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5G2Rb.html" rel="bookmark" class="title">3ds Max人头建模全过程</a>
					<div>
						首先,我们还是要画一个草图,导入MAX中做为背景,不要小看草图的作用.当你以后布线时不知道结 构哪里对哪里时它可起到一个关键作用,能够帮你理清思路. 在PS中调整好草图的长宽,使它们高度一致,不然会很 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPwoGz.html" rel="bookmark" class="title">Java 语法介绍&lpar;四&rpar;：数组</a>
					<div>
						1:数组说明 数组是Java语言中的特殊类型.它们存放能通过索引来引用的一系列对象,另外,你可以定义数组的数组,下面是一些示例: int i[]; char C[]; float f[][]; 2:数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKnx6M.html" rel="bookmark" class="title">PS画一个超写实柠檬</a>
					<div>
						完成图 具体步骤如下: 1.新建一个大小适当的文档,新建以个图层,画出柠檬的形状,填充颜色:#eef053,然后双击图层调出图层样式,参数设置如下图. 2.画完柠檬的外形后,把柠檬的所有图层放到一个组 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1EPraM.html" rel="bookmark" class="title">电脑显卡接口类型知识大全</a>
					<div>
						  就目前而言,显卡上面常见的输出接口是比较丰富的,如上图所示.我们所熟知的有以下几种:VGA.DVI.HDMI和DP.这四种输出接口是显卡上最常见的输出接口,VGA是大家再熟悉不过的输出接口了,但是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ok6Db.html" rel="bookmark" class="title">win7电脑中突然出现一个本地磁盘Q怎么办？</a>
					<div>
						  一般说来,在w764位旗舰版中,咱们本地磁盘都是c.d.e.f盘组成的,即便是有U盘或者是硬盘的介入,一般也会用H.K.G等符号来命名,而且从另一个层面来说,咱们本地磁盘一般不会太多,因为分出过多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaRGLz.html" rel="bookmark" class="title">软件不启动会不会占用内存和CPU</a>
					<div>
						电脑上软件装多了为什么会卡,软件不启动会不会占用内存和CPU? 回答: 软件不启动就不会被加载到内存中,但目前有不少流氓的或者不流氓的软件都会在操作系统的后台搞一些小进程,这样不请自来的不速之客多了, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZdQxoM.html" rel="bookmark" class="title">电脑显示器有波纹怎么办&quest;</a>
					<div>
						  电脑水波纹问题在使用液晶显示器时会时常发生.液晶显示器出现的所谓的水波纹问题,就是指屏幕上的暗波线发生干扰的一种形式,给用户的感觉就像是水面上的波纹一样.有些朋友说,即使刚买的LCD出现了水波纹现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNXY8M.html" rel="bookmark" class="title">天猫超市优惠券怎么领取</a>
					<div>
						  1.首先进入天猫商城,并登陆自己的账号,然后进入&quot;积分俱乐部&quot;,如下图所示: 2.进入天猫积分俱乐部之后,我们再这个界面中,往下拉,在偏底部的&quot;超值好券&quot;下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32N9kz.html" rel="bookmark" class="title">友情链接交换与PR值更新总结</a>
					<div>
						  从佛罗里达更新到现在也有四个月左右了.据我以我网站的观察,PR更新了两次,而这两次的PR更新规则也与hilltop算法的原则非常吻合.大家可以由于联想到什么或者会得到相应的结论了吧.下面是我对这次 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWPaOz.html" rel="bookmark" class="title">RSS订阅服务的产品</a>
					<div>
						 在官方博客上, Google公布了最新的&quot;春季大扫除(Spring Cleaning)&quot;名单,即将关闭8项服务,包括很受欢迎的RSS订阅服务Google Reader. 很多用户 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBJnDb.html" rel="bookmark" class="title">MySQL5&period;7&period;9压缩包安装配置</a>
					<div>
						第一步:从官网下载mysql-5.7.9-win32.zip 或 mysql-5.7.9-winx64.zip 第二步:解压缩,在根目录下复制my-default.ini 为my.ini,在my.in ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBvyrb.html" rel="bookmark" class="title">从Docker的转变，谈容器生态与微服务的发展</a>
					<div>
						更多深度文章,请关注:https://yq.aliyun.com/cloud 编者按:容器技术目前已经成为技术圈内的&quot;常识&quot;,但是容器生态能否健康发展仍然任重道远.在收获最初的赞扬 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0lkVM.html" rel="bookmark" class="title">ejb3&period;0-spring&sol;EJB3&period;0 注入 和 实例化的差别？</a>
					<div>
						问题描述 spring/EJB3.0 注入 和 实例化的差别? 10C 1.具体的理论大概都知道了. 参考:spring 注入 和 实例化的差别(别说没区别) 2.现在有个问题,就是利用注解注入的时候 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWGm5z.html" rel="bookmark" class="title">selenium2-Selenium2、毫无头绪的测试工具，救命！</a>
					<div>
						问题描述 Selenium2.毫无头绪的测试工具,救命! 最近老大丢给我一个任务,selenium2做客户端测试 第一次接触这个,在网上找了好多资料去看,有几个疑问需要各位解答, 以一个登陆画面为例子 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRABOp.html" rel="bookmark" class="title">使用vmstat和iostat命令进行Linux性能监控</a>
					<div>
						使用vmstat和iostat命令进行Linux性能监控 这是我们正在进行的Linux命令和性能监控系列的一部分.vmstat和iostat两个命令都适用于所有主要的类unix系统(Linux/uni ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPk8arM.html" rel="bookmark" class="title">房产网的关键词部署不当会造成降权</a>
					<div>
						摘要: 相信站长们都应该知道,房产网小到一个县城,大到一个省市,当房产网越能满足用户的需求和用户的方便,那么就会有几十甚至上百个房产网竞争某一个地区的关键词,而在这方面会 相信站长们都应该知道,房产网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgkwOM.html" rel="bookmark" class="title">Sys&period;ArgumentNullException&colon; Value cannot be null&period;出现这样的错误怎么解决</a>
					<div>
						问题描述 我用的是vs2008的第三发工具包做的一个DragPanelExtender控件的实例,但老是出现 Sys.ArgumentNullException:Valuecannotbenull.怎 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx0vYyM.html" rel="bookmark" class="title">PgSQL &CenterDot; 应用案例 &CenterDot; 阿里云RDS金融数据库&lpar;三节点版&rpar; - 背景篇</a>
					<div>
						背景 提到金融级数据库,大家可能不约而同的会想到Oracle,DB2等商业数据库.但是随着开源数据库的发展,开源数据库正在逐渐成为数据库产业的核心,比如MySQL.PostgreSQL数据库 ,已经深 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx0KY0M.html" rel="bookmark" class="title">传Verizon无线将允许用户使用Skype网络电话</a>
					<div>
						北京时间2月13日午间消息,据国外媒体昨日报道,消息人士透露,美国最大的移动运营商Verizon无线将允许用户使用Skype网络电话,借此应对AT&amp;T的竞争. 预装Skype 消息人士表示,该 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8YWo9z.html" rel="bookmark" class="title">雅虎Axis Chrome插件现安全漏洞已禁用</a>
					<div>
						[搜狐IT消息]北京时间5月24日消息,据国外媒体报道,在开发者报告安全漏洞后,雅虎已经禁用了Axis浏览器的Chrome插件.雅虎发言人发表声明称:&quot;雅虎非常关注在线安全问题.我们 刚刚收 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2v8mM.html" rel="bookmark" class="title">C&num;如何将DataTable导出到Excel解决方案&lowbar;C&num;教程</a>
					<div>
						最近,由于公司项目中需要将系统内用户操作的所有日志进行转存备份,考虑到以后可能还需要还原,所以最后决定将日志数据备份到Excel中. 下面是我项目当中Excel.cs这个类的全部代码,通过这个类可以很 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvY3w9b.html" rel="bookmark" class="title">js读取csv文件并使用json显示出来&lowbar;javascript技巧</a>
					<div>
						摘要: 前面分享了用js将json数据下载为csv文件,方便后期管理.但是对于测试人员更希望能够以页面的形式展现任务,所以就做了一个将csv文件展现在页面上的例子. 代码: 复制代码 代码如下: &l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mlm4nOp.html" rel="bookmark" class="title">&period;net decimal保留指定的小数位数&lpar;不四舍五入&rpar;&lowbar;实用技巧</a>
					<div>
						前言 项目中遇到分摊金额的情况,最后一条的金额=总金额-已经分摊金额的和. 这样可能导致最后一条分摊的时候是负数,所以自己写了一个保留指定位数小数的方法. 扩展方法的使用,使得调用起来很优雅. 示例代 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWj5lz.html" rel="bookmark" class="title">VS2008 C&num;调试DLL项目，但项目中没有可执行文件源码，只有已生成的EXE可执行文件</a>
					<div>
						问题描述 各位,如果只有C#的DLL项目代码,但解决方案中没有可执行文件的源代码,只有已经生成的可执行文件(DLL的宿主),能否调试此DLL项目? 解决方案 解决方案二:&quot;能否调试此DLL项 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9j6Kgp.html" rel="bookmark" class="title">chrome CEF3 CefInitialize初始化速度问题</a>
					<div>
						问题描述 chrome CEF3 CefInitialize初始化速度问题 CEF3嵌入MFC对话框后, 在每天第一次打开软件时发现 CEF CefInitialize初始化速度慢,不知道怎么回事?  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.148 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
